---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

<!-- markdownlint-disable MD002 -->

## Prerequisites

- We realize there may be a lot of data requested here. We ask only that you do your best to provide as much information as possible so we can better help you.
- Read the [contributing guidelines](https://github.com/barbajs/barba/blob/master/.github/CONTRIBUTING.md).
- Support questions are better asked in one of the following locations:
  - [Our chat](https://barbajs.slack.com)
  - [Stack Overflow](https://stackoverflow.com/questions/tagged/barbajs)
- Ensure the issue isn't already reported.

> _Delete the above section and the instructions in the sections below before submitting_

---

## The problem

Briefly describe the issue you are experiencing (or the feature you want to see added to Barba).

Tell us what you were trying to do and what happened instead.

Remember, this is _not_ a place to ask questions. For that, get your invite to [https://barbajs.slack.com](https://join.slack.com/t/barbajs/shared_invite/enQtNTU3NTAyMjkxMzAyLTkxYWUwZmM1YWQxMmNlYmE0ZjY4NDQxMGUxYjkwYWFlMzEzOWM4OTRhMWRmYTQyYzFlMmQ3OGFmYmI3MWY0OWY)!

## Description

### Details

If necessary, describe the problem you have been experiencing in more detail.

### Expected behaviour

Tell us what should happen

### Actual behaviour

Tell us what happens instead

### Code To Reproduce Issue [ Good To Have ]

```js
// Avoid posting hundreds of lines of source code.
// Edit to just the relevant portions.
```

### Steps to reproduce issue [ Good To Have ]

Tell us how to reproduce this issue. Please provide a working demo, you can use this template as a base.

---

## Relevant Links

- If your project is public, link to the repo so we can investigate directly.
- **BONUS POINTS:** Create a [minimal reproduction](http://stackoverflow.com/help/mcve) and upload it to GitHub. This will get you the fastest support.

## Environment

- Barba version that exhibits the issue:
- Build used:
  - [ ] module (esm/)
  - [ ] browser (dist/)
  - [ ] main (lib/)
- Browser OS/version used:
